<template>
    <q-card class="trunk-details">
        <q-card-section>
            <h5 class="card-head">
                {{ trunk.gateway }} | {{ trunk.caller_number }}
            </h5>
        </q-card-section>

        <q-card-section>
            <div style="display: flex; align-items: center; max-width: 450px; margin: 0px auto 20px auto;">
                <p style="flex-grow: 7; margin-bottom: 0px;">{{ $t('trunks.max_capacity') }}</p>
                <q-input v-model="capacity" @change="(e) => handleCapacityUpdated(e.target.value)" type="number" step="10"
                    filled style="flex-grow: 1;" />
            </div>

            <div style="display: flex; align-items: center; max-width: 450px; margin: 0px auto 20px auto;">
                <p style="flex-grow: 1; margin-bottom: 0px;">{{ $t('trunks.dial_local') }}</p>
                <q-checkbox style="flex-grow: 1;" :value="dialLocal" @input="(newVal) => handleLocalDialChange(newVal)" />
            </div>

            <div v-if="dialLocal" style="display: flex; align-items: center; max-width: 450px; margin: 0px auto 20px auto;">
                <p style="flex-grow: 1; margin-bottom: 0px;">{{ $t('trunks.dial_local_use_zero') }}</p>
                <q-checkbox style="flex-grow: 1;" :value="localZero" @input="(newVal) => handleLocalZeroChange(newVal)" />
            </div>

            <q-separator inset />
        </q-card-section>

        <q-card-section>
            <h6>{{ $t('trunks.active_codes', [Object.keys(activeCodes).length]) }}</h6>
            <q-list separator>
                <q-item v-for="(codeVal, key) in activeCodes || {}" :key="key">
                    <TrunkCountry :code="key" :countryString="codeVal.countries" :cost="codeVal.cost"
                        :onDataUpdate="codeUpdated" :active="true" :disabled="dialLocal" />
                </q-item>
            </q-list>
        </q-card-section>

        <q-card-section>
            <h6></h6>
            <q-expansion-item expand-separator icon="phone_disabled"
                :label="$t('trunks.inactive_codes', [Object.keys(inactiveCodes).length])">
                <q-list separator style="margin-bottom:60px">
                    <q-item v-for="(codeVal, key) in inactiveCodes || {}" :key="key">
                        <TrunkCountry :code="key" :countryString="codeVal.countries" :cost="codeVal.cost"
                            :onDataUpdate="codeUpdated" :active="false" :disabled="dialLocal" />
                    </q-item>
                </q-list>
            </q-expansion-item>

        </q-card-section>
    </q-card>
</template>
 
<script>

import { uniqueCodesWithCountries, parseNumber } from "../utils/phone";
import TrunkCountry from "./TrunkCountry.vue";

export default {
    props: {
        trunk: {
            required: true
        },
        updateTrunk: {
            required: true
        }
    },
    data()
    {
        return {
            capacity: 0,
            dialLocal: false,
            localZero: true,
            allCodes: {},
        }
    },
    watch:
    {
        trunk: {
            immediate: true,
            handler(newVal, oldVal)
            {
                if (!oldVal)
                {
                    // rtdb has bound
                    this.capacity = parseInt(this.trunk.capacity);
                    this.dialLocal = this.trunk.removeIntCode === true;
                    this.localZero = this.trunk.addZeroToLocal === undefined ? true : this.trunk.addZeroToLocal;
                    this.allCodes = this.initialCodeCosts();
                }
            }
        }
    },
    computed:
    {
        activeCodes()
        {
            let toRet = {};
            let trunkCode = '+' + parseNumber(this.trunk.caller_number).countryCallingCode

            for (const code in this.allCodes) 
            {
                if(this.dialLocal)
                {
                    if (code == trunkCode)
                    {
                        toRet[code] = this.allCodes[code];
                    }
                }
                else if (this.allCodes[code].active)
                {
                    toRet[code] = this.allCodes[code];
                }
            }

            return toRet;
        },
        inactiveCodes()
        {
            let toRet = {};
            let trunkCode = parseNumber(this.trunk.caller_number).countryCallingCode

            for (const code in this.allCodes) 
            {
                if ((this.dialLocal && code != trunkCode) || !this.allCodes[code].active) 
                {
                    toRet[code] = this.allCodes[code];
                }
            }

            return toRet;
        }
    },
    methods: {
        callUpdate()
        {
            this.updateTrunk(this.trunk.caller_number, this.allCodes, this.capacity, this.dialLocal, this.localZero);
        },
        codeUpdated(code, active, cost)
        {
            this.allCodes[code].cost = cost;
            this.allCodes[code].active = active;
            this.callUpdate();
        },
        handleLocalDialChange(newVal)
        {
            if(!newVal)
            {
                this.dialLocal = false;
                this.callUpdate();
                return;
            }

            this.$q.dialog({
                title: this.$t("confirm"),
                message: this.$t("trunks.dial_local_confirm"),
                ok: { label: this.$t("confirm"), flat: true },
                cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
            })
            .onOk(async () =>
            {
                this.dialLocal = true;
                this.callUpdate();
            });
        },
        handleLocalZeroChange(newVal)
        {
            this.localZero = newVal;
            this.callUpdate();
        },
        handleCapacityUpdated(newCapacity)
        {
            this.capacity = newCapacity;
            this.callUpdate();
        },
        initialCodeCosts()
        {
            const countryStrings = uniqueCodesWithCountries();
            let toRet = {};

            for (const code in countryStrings)
            {
                let cost = 0;
                let active = false;

                if (Object.hasOwnProperty.call(this.trunk.codes_cost_per_min, code))
                {
                    cost = this.trunk.codes_cost_per_min[code];
                    active = true;
                }

                toRet[code] = {
                    countries: countryStrings[code].join(', '),
                    cost: cost,
                    active: active
                }
            }

            return toRet;
        }
    },
    components: {
        TrunkCountry
    }
};
</script>
<style scoped>
.trunk-details {
    width: 100%;
    padding: 20px;
}

.card-head {
    text-transform: capitalize;
}

h5,
h6 {
    margin: 0px;
}
</style>